#pragma once

class CFileEventWatcher : public CRhinoEventWatcher
{
  void OnNewDocument(CRhinoDoc& doc) override;
  void OnEndOpenDocument(CRhinoDoc& doc, const wchar_t* filename, BOOL bMerge, BOOL bReference) override;
};


class CIdleEventWatcher : public CRhinoIsIdle
{
public:
  CIdleEventWatcher();
  void Notify(const class CRhinoIsIdle::CParameters& params) override;
};


class CTestPlugIn : public CRhinoUtilityPlugIn
{
public:
  CTestPlugIn();
  ~CTestPlugIn() = default;

  // Required overrides
  const wchar_t* PlugInName() const override;
  const wchar_t* PlugInVersion() const override;
  GUID PlugInID() const override;
  
  // Additional overrides
  BOOL OnLoadPlugIn() override;
  void OnUnloadPlugIn() override;
  CRhinoPlugIn::plugin_load_time PlugInLoadTime() override;

private:
  ON_wString m_plugin_version;
};

// Return a reference to the one and only CTestPlugIn object
CTestPlugIn& TestPlugIn();
